#This is free software; you can redistribute it and/or modify it under
#the terms of the GNU General Public License as published by the Free
#Software Foundation; either version 2, or (at your option) any later
#version.

#This is distributed in the hope that it will be useful, but WITHOUT
#ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#for more details.

#version 0.1.1

from warground import *
from whrandom import *

#Privat Classes: it's allowed to examine all variables and instances, but not to change
#clan-class is in warground.py and has the variables id [0..9], count [0..10], and n
#robot-class is has the variables x, y, id [00..99], look(), get_robots(), clan and n
#All APT-functions are functions of the robot class. the clan class has no API

class robot(robot_base): 
    #Clan functions
    def get_clan_id(self):
        return int(self.clan.id)
    def get_clan_members(self):
        ret = []
        for r in self.get_robots():
            if r.clan is self.clan:
                ret.append(r)
        return ret
    def can_make(self):
        return (10 - self.clan.count)
    def set_clan_info(self, key, value):
        setattr(self.clan, key, value)
    def get_clan_info(self, key):
        try:
            return getattr(self.clan, key)
        except:
            return None           
    def clan_counter(self):
        n = get_clan_info('counter')
        if  n == None:
            n = 1
        else:
            n = n + 1
        set_clan_info('counter', n)
        return n
    def set_clan_target(self, t):
        self.set_clan_info('clan_target', t)
    def get_clan_target(self):
        return self.get_clan_info('clan_target')
    def get_clan_dir(self):
        friend = self.get_closest_friend()
        if self.distance(friend) > 1:
            return self.direction(friend)            
        else:
            return self.direction(self.get_clan_target())    

    #eRobot functions        
    def get_robot_id(self):
        return int(self.id)
    def get_closest_friend(self):
        close = None
        for r in self.get_robots():
            if (self.distance(r) < self.distance(close)) and r.get_clan_id() == self.get_clan_id() and  r is not self:
                close = r         
        return close
    def get_closest_enemy(self):
        close = None
        for r in self.get_robots():            
            if (self.distance(r) < self.distance(close)) and r.get_clan_id() != self.get_clan_id():
                close = r         
        return close
    def set_robot_info(self, key, value):
        setattr(self, key, value)
    def get_robot_info(self, key):
        try:
            return getattr(self, key)
        except:
            return None           
    def robot_counter(self):
        n = get_robot_info('counter')
        if  n == None:
            n = 1
        else:
            n = n + 1
        set_robot_info('counter', n)
        return n
    def distance(self, to): 
        if to == None: 
            return None
        else:
            return (abs(self.x-to.x) + abs(self.y-to.y))            
    def direction(self, to):
        if to == None: 
            return None
        else:
            dx, dy = to.x - self.x, to.y - self.y
            if abs(dx) > abs(dy):
                if dx <= 0: ret = "left"
                else: ret = "right"    
            else:
                if dy <= 0: ret = "up"
                else: ret = "down"             
            return ret        
    def test_fight(self, enemy):
        #has a bug
        if self.clan is enemy.clan: 
            return 0
        if enemy.x-self.x == 0:
            sx, sy = 0, enemy.y-self.y/abs(enemy.y-self.y)
        elif enemy.y-self.y == 0:
            sx, sy = enemy.x-self.x/abs(enemy.x-self.x), 0
        else:
            return 0
        dx, dy = sx, sy
        while (enemy.x != self.x+dx) and (enemy.y != self.y+dy):
             target = self.look(self.x+dx, self.y+dy )
             if target == None:
                 return 0
             elif isinstance( target, wall ):                                        
                 return 0
             elif target.clan is not enemy.clan:
                 return 0
             else:
                 dx, dy = dx+sx, dy+sy           
            
        for dx in range(sx, px, sx):
            for dy in range(sy, py, sy):
                target = self.look(self.x+dx, self.y+dy )
                if target == None:
                    return 0
                elif isinstance( target, wall ):                                        
                    return 0
                elif target.clan is not enemy.clan:
                    return 0
                elif target is enemy:
                    break
                    
        me, you = 0, 0
        for s in self.get_robots():
            if (abs( s.x-(enemy.x) ) <= 1) and (abs( s.y-(enemy.y) ) <= 1) :
                if (s.clan is enemy.clan) and (s is not enemy):
                    you = you+1 
                elif (s.clan is self.clan) and (s is not self):
                    me = me+1
        if me <= you: 
            return 0
        else:             
            return 1
    def get_fight_dir(self):
        #has a bug
        for e in self.get_robots():
            if self.test_fight(e) == 1:
                px, py = enemy.x-self.x, enemy.y-self.y
                if px > 0: return "rigth"
                elif px < 0: return "left"
                elif py > 0: return "down"
                elif py < 0: return "up"                
        return None

    #Other functions    
    def cmd_random(self):
        return ["pass", "move", "make"][randint(0,2)]
    def dir_random(self):
        return ["up", "left", "down", "right"][randint(0,3)]   
    def dir_opposite(self, dir):
        if dir == "up": return "down"
        elif dir == "down": return "up"
        elif dir == "left": return "right"
        elif dir == "right": return "left"
        else: return ""
   